﻿#include "adc.h"

//静的関数メンバの実体
bool adc::init_flag = true;

adc::adc(void)
{
	if(init_flag){
		
		init_flag = false;
		
		ADMUX = 0x40;	//0100 0000	基準電圧:AVcc
		DDRC = 0x00;	//0000 0000 PORTC初期化
		PORTC = 0x00;	//0000 0000 Hi-Z
		DIDR0 = 0x3F;	//0011 1111 PC0-PC5のﾃﾞｼﾞﾀﾙ入力禁止
	
		//ADCスタート
		#if F_CPU == 1000000UL
			ADCSRA = 0x8C;	//1000 1100	ｸﾛｯｸ 1MHz
		#elif F_CPU == 8000000UL
			ADCSRA = 0x8E;	//1000 1110	ｸﾛｯｸ 8MHz
		#else
			#error AD_converter::error
		#endif
	}
}

adc::~adc()
{
}

int adc::get(int index)
{
	//AD変換するPORTを指定
	ADMUX = (ADMUX & 0xF0)|(index<<MUX0);
	//AD変換開始
	ADCSRA = (1<<ADSC)|(ADCSRA & 0xBF);
	//AD変換完了まで待機
	while(ADCSRA & (1<<ADSC));
	return ADC;
}