﻿#include "i2cMt.h"

//静的メンバ変数の実体
bool i2cMt::init_flag = true;

i2cMt::i2cMt(int scl)
	:SCLclock(scl)
{
	if (init_flag){
		init_flag = false;
		
		TWSR = (0<<TWPS1)|(0<<TWPS0);	//分周1
		TWBR = (F_CPU / SCLclock - 16) / 2;
	}
}

i2cMt::~i2cMt()
{
}

char i2cMt::send(unsigned char SLAadress,char data)
{
	//ｽﾀｰﾄｺﾝﾃﾞｨｼｮﾝ送信
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	//ｽﾀｰﾄｺﾝﾃﾞｨｼｮﾝ送信待機
	while(!(TWCR & (1<<TWINT)));
	
	//TWIｽﾃｰﾀｽをﾁｪｯｸ
	if(TW_STATUS == TW_START){
		
		//送信主装置へ移行動作 通信先設定
		TWDR = (SLAadress<<TWD1)|(TW_WRITE<<TWD0);
		TWCR = (1<<TWINT)|(1<<TWEN);
		while(!(TWCR & (1<<TWINT)));
		
		//TWIｽﾃｰﾀｽをﾁｪｯｸ
		if(TW_STATUS == TW_MT_SLA_ACK){
			
			//送信ﾃﾞｰﾀをﾚｼﾞｽﾀに格納
			TWDR = data;
			//送信開始
			TWCR = (1<<TWINT)|(1<<TWEN);
			//送信完了待機
			while(!(TWCR & (1<<TWINT)));
			
			//TWIｽﾃｰﾀｽをﾁｪｯｸ
			if (TW_STATUS == TW_MT_DATA_ACK){
				//ｽﾄｯﾌﾟｺﾝﾃﾞｨｼｮﾝ送信
				TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN)	;
				
				return 0;
			}
		}
	}
	
	//ｽﾄｯﾌﾟｺﾝﾃﾞｨｼｮﾝ送信
	TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN)	;
	
	return -1;
}

char i2cMt::recieve(unsigned char SLAadress,char* data)
{
	//ｽﾀｰﾄｺﾝﾃﾞｨｼｮﾝ送信
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)	;
	//ｽﾀｰﾄｺﾝﾃﾞｨｼｮﾝ送信完了待機
	while(!(TWCR & (1<<TWINT)));
	
	//TWIｽﾃｰﾀｽをﾁｪｯｸ
	if(TW_STATUS == TW_START){
		
		//受信主装置へ移行動作 通信先設定
		TWDR = (SLAadress<<TWD1)|(TW_READ<<TWD0);
		TWCR = (1<<TWINT)|(1<<TWEN);
		while(!(TWCR & (1<<TWINT)));
			
		//受信完了待機
		TWCR = (1<<TWINT)|(1<<TWEN);
		while(!(TWCR & (1<<TWINT)));
		*data = TWDR;
			
		//ｽﾄｯﾌﾟｺﾝﾃﾞｨｼｮﾝ送信
		TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN)	;
				
		return 0;
	}
	//ｽﾄｯﾌﾟｺﾝﾃﾞｨｼｮﾝ送信
	TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN)	;
	
	return -1;
}