﻿#include "uart.h"

//静的メンバ変数の実体
bool uart::init_flag = true;

uart::uart(int bd)
	:baudrate(bd)
{
	if(init_flag){
		
		init_flag = false;
		
		UBRR0=F_CPU/16/baudrate-1;
		UCSR0C=(3<<UCSZ00)|(0<<USBS0);
		UCSR0B=(1<<RXEN0)|(1<<TXEN0);	
		//(1<<RXCIE0)	受信完了割り込み許可
		//(1<<TXCIE0)	送信完了割り込み許可
		//(1<<UDRIE0)	送信ﾃﾞｰﾀﾚｼﾞｽﾀ空き割り込み許可
	}												
}

uart::~uart()
{
}

void uart::putch(char c)
{
	//UDRE0ビットが1になるまで待つ
	while(!(UCSR0A & (1<<UDRE0)));
	UDR0 = c;
}

char uart::getc(void)
{
	//RXC0ビットが1になるまで待つ
	while(!(UCSR0A & (1<<RXC0)));
	return UDR0;
}

void uart::puts(char* str)
{
	while (*str!='\0'){
		putch(*str);
		str++;
	}
}

void uart::gets(char* str)
{
	int i = 0;
	while(1){
		char c = getc();
		if((c == '\n') || (c == '\r')){
			str[i] = '\0';
			break;
		}
		str[i++] = c;
	}
}

void uart::skip(void)
{
	putch('\n');
	putch('\r');
}

int uart::printf(const char *format, ...)
{
	va_list argptr;
	char buffer[200];
	int argNum;
	
	va_start(argptr,format);
	argNum = vsprintf(buffer,format,argptr);
	va_end(argptr);
	
	puts(buffer);

	return argNum;
}